Attribute VB_Name = "Module1"
Option Explicit

'Dclaration des constantes
Public Const IP_SUCCESS As Long = 0
Public Const MAX_WSADescription As Long = 256
Public Const MAX_WSASYSStatus As Long = 128
Public Const WS_VERSION_REQD As Long = &H101
Public Const WS_VERSION_MAJOR As Long = WS_VERSION_REQD \ &H100 And &HFF&
Public Const WS_VERSION_MINOR As Long = WS_VERSION_REQD And &HFF&
Public Const MIN_SOCKETS_REQD As Long = 1
Public Const SOCKET_ERROR As Long = -1

'Dclaration du type de donnes Winsock
Public Type WSADATA
wVersion As Integer
wHighVersion As Integer
szDescription(0 To MAX_WSADescription) As Byte
szSystemStatus(0 To MAX_WSASYSStatus) As Byte
wMaxSockets As Long
wMaxUDPDG As Long
dwVendorInfo As Long
End Type

'La fonction de rsolutions d'adresses DNS appelle
'GetHostByName fait partie de la librairie Wsock32.dll
Private Declare Function gethostbyname Lib "wsock32" _
(ByVal hostname As String) As Long

'declaration des procedures auxilliares
Private Declare Sub CopyMemory Lib "kernel32" _
Alias "RtlMoveMemory" _
(xDest As Any, _
xSource As Any, _
ByVal nbytes As Long)

Private Declare Function lstrlenA Lib "kernel32" _
(lpString As Any) As Long

Public Declare Function WSAStartup Lib "wsock32" _
(ByVal wVersionRequired As Long, _
lpWSADATA As WSADATA) As Long

'Procedure de nettoyage des sockets
Public Declare Function WSACleanup Lib "wsock32" () As Long

'Routine d'initialisation du socket
Public Function SocketsInitialize() As Boolean

     Dim WSAD As WSADATA
     Dim success As Long

     SocketsInitialize = WSAStartup(WS_VERSION_REQD, WSAD) = IP_SUCCESS

End Function

'routine de nettoyage du socket retournant une msg d'erreur si
'necessaire
Public Sub SocketsCleanup()
     If WSACleanup() <> 0 Then
     MsgBox "Une erreur  eu lieu lors de la fermeture.", vbExclamation
     End If
End Sub

'Cette fonction est en faite celle qu'on va appeller  chaque fois pour
'rsoudre un nom (pass en tant que String) et qui va nous retourner
'une adresse IP (en String galement)
Public Function GetIPFromHostName(ByVal sHostName As String) As String

'Conversion du nom d'hote en adresse IP

     Dim nbytes As Long
     Dim ptrHosent As Long
     Dim ptrName As Long
     Dim ptrAddress As Long
     Dim ptrIPAddress As Long
     Dim sAddress As String

     sAddress = Space$(4)

     ptrHosent = gethostbyname(sHostName & vbNullChar)

     If ptrHosent <> 0 Then

'la fonction gethostbyname nous retourne un POINTEUR vers la structure
'HOSENT en mmoire. On va recopier l'adresse IP en mmoire, qui 'commence 12 octets aprs le dbut de la structure

     ptrAddress = ptrHosent + 12

'get the IP address
     CopyMemory ptrAddress, ByVal ptrAddress, 4
     CopyMemory ptrIPAddress, ByVal ptrAddress, 4
     CopyMemory ByVal sAddress, ByVal ptrIPAddress, 4

     GetIPFromHostName = IPToText(sAddress)

     End If
End Function

'Cette fonction sert  transformer la structure retrouve d'une adresse
'IP (char x 4) en String du type "123.123.123.123"
Private Function IPToText(ByVal IPAddress As String) As String

     IPToText = CStr(Asc(IPAddress)) & "." & _
     CStr(Asc(Mid$(IPAddress, 2, 1))) & "." & _
     CStr(Asc(Mid$(IPAddress, 3, 1))) & "." & _
     CStr(Asc(Mid$(IPAddress, 4, 1)))

End Function
'----------fin du code module


